<template>
    <div>
        <section class="hero is-transparent">
            <div class="hero-body">
                <div class="container has-text-centered">
                    <h1 class="title">
                        {{ $t('auth.title') }}
                    </h1>
                    <h2 class="subtitle">
                        {{ $t('auth.subtitle') }}
                    </h2>
                </div>
            </div>
        </section>
        <br>
        <div class="container">
            <p class="content">
                {{ $t('auth.text') }}
            </p>
            <div class="field">
                <label for="password" class="label">{{ $t('auth.field.label') }}</label>
                <div class="control has-icons-left">
                    <input @keypress.enter="submitForm" :type="done ? 'password':'text'" class="input" :class="{'is-danger': err}"
                           :disabled="loading || done" id="password" :placeholder="$t('auth.field.placeholder')" v-model="token"
                           autocomplete="current-password">
                    <span class="icon is-small is-left">
                        <font-awesome-icon :icon="['fas', 'lock']"></font-awesome-icon>
                    </span>
                </div>
                <p class="help is-danger" v-if="err">{{ $t('auth.err') }}</p>
            </div>
            <button class="button is-primary" :class="{'is-loading': loading}" :disabled="done" @click="submitForm">{{ $t('auth.btn') }}</button>
            <button class="button is-danger" v-if="done" @click="logout">{{ $t('auth.dis') }}</button>
        </div>
    </div>
</template>

<script lang="ts">
    import Vue from 'vue';
    import { adminStore } from "~/utils/store-accessor";

    export default Vue.extend({
        data() {
            return {
                loading: false,
                done: false,
                err: false,
                token: adminStore.auth
            }
        },

        methods: {
            submitForm() {
                this.loading = true;
                this.$axios.post(`${process.env.APP_URL}/api/auth`, {
                    api_token: this.token
                }).then(res => {
                    this.loading = false;
                    this.done = true;
                    adminStore.setAuth(this.token);
                }).catch(err => {
                    this.loading = false;
                    this.err = true;
                });
            },
            logout() {
                adminStore.setAuth('');
                this.token = '';
            }
        },

        watch: {
            token(_now, _old) {
                this.err = false;
                this.done = false;
            }
        },

        mounted() {
            if (adminStore.auth !== '') {
                this.token = adminStore.auth;
                this.done = true;
            }
        }
    });
</script>
